//
//  GifObjects.h
//  GifMaker
//
//  Copyright 2006 T Endo. 
//
// This file is distributed under General Public Licence version 2 (GPLv2).
//

#import <Foundation/Foundation.h>

// simple class of a two dimentional point inheriting NSObject
@interface LinePoint : NSObject {
	int x;
	int y;
}
-(id)initWithPosition: (int)x :(int)y;
+(LinePoint*) point:(int)x :(int)y;
-(int)getX;
-(int)getY;
-(NSString*)description;
@end

// a class of draing line containing color and thickness information
@interface GifLine : NSObject {
	NSArray* points;
	int lineWidth;
	int r;
	int g;
	int b;
}

-(id)initWithData: (NSArray*)points width:(int)width red:(int)r green:(int)g blue:(int)b;
-(void)dealloc;
-(int)getPointNumber;
-(int)getThickness;
-(void)getColor :(int*)red :(int*)green :(int*)blue;
-(int)getX:(int)num;
-(int)getY:(int)num;
-(NSString*)description;
-(GifLine*)subLine:(int)start :(int)size;
@end

// color table
// Because GIF images only contains 256 colors, this table confirms the allocated colors
// are equal to or less than 256. Colors that have been allocated are converted to the
// same palette code.
@interface GifColorTable : NSObject {
	int num;
	int reserved;
	int* red;
	int* green;
	int* blue;
	int* palette;
}

-(id)init;
-(void)dealloc;
-(int)addPalette: (int)red :(int)green :(int)blue :(int)palette;
-(int)getPalette: (int)red :(int)green :(int)blue;

@end
