//
//  GifObjects.m
//  GifMaker
//
//  Created by Takaho A. Endo on 06/02/14.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "GifObjects.h"

@implementation GifColorTable
-(id)init {
	[ super init ];
	red     = (int*)malloc( sizeof( int ) * 256 );
	green   = (int*)malloc( sizeof( int ) * 256 );
	blue    = (int*)malloc( sizeof( int ) * 256 );
	palette = (int*)malloc( sizeof( int ) * 256 );
	num = 0;
	return self;
}

-(void)dealloc {
	[ super dealloc ];
	free( red );
	free( green );
	free( blue );
	free( palette );
}

-(int)addPalette: (int)r :(int)g: (int)b :(int)p {
	int i;
	for ( i = 0; i < num; i++ ) {
		if ( red[ i ] == r && green[ i ] == g && blue[ i ] == b ) {
			return palette[ i ];
		}
	}
	if ( num >= 255 ) {
		NSLog( @"more than 255 colors" );
		return -1;
	}
	red[ num ] = r;
	green[ num ] = g;
	blue[ num ] = b;
	palette[ num ] = p;
	num++;
	return num - 1;
}
-(int)getPalette: (int)r :(int)g :(int)b {
	int i;
	for ( i = 0; i < num; i++ ) {
		if ( red[ i ] == r && green[ i ] == g && blue[ i ] == b ) {
			return palette[ i ];
		}
	}
	return -1;
}
@end

@implementation LinePoint

-(id)initWithPosition: (int)xpos :(int)ypos {
	[ super init ];
	x = xpos;
	y = ypos;
	return self;
}
+(LinePoint*)point:(int)x :(int)y {
	LinePoint* p = [ [ LinePoint alloc ] initWithPosition :x :y ];
	return p;
}
-(int)getX {
	return x;
}
-(int)getY {
	return y;
}
-(NSString*)description {
	NSString* str = [ NSString stringWithFormat:@"( %d, %d )", x, y ];
	[ str retain ];
	return str;
}
@end

@implementation GifLine

-(id)initWithData: (NSArray*)thePoints width:(int)width red:(int)rval green:(int)gval blue:(int)bval {
	[ super init ];
	points = thePoints;
	lineWidth = width;
	r = rval;
	g = gval;
	b = bval;
	[ points retain ];
	return self;
}

-(void)dealloc {
	[ super dealloc ];
	[ points release ];
}

-(int)getPointNumber {
	return [ points count ];
}
-(int)getThickness {
	return lineWidth;
}
-(void)getColor :(int*)redVal :(int*)greenVal :(int*)blueVal {
	*redVal = r;
	*greenVal = g;
	*blueVal = b;
}
-(int)getX:(int)num {
	return [ [ points objectAtIndex:num ] getX ];
}

-(int)getY:(int)num {
	return [ [ points objectAtIndex:num ] getY ];
}

-(GifLine*)subLine :(int)start :(int)size {
	if ( start < 0 ) start = [ points count ] + start;
	if ( start + size > [ points count ] ) size = [ points count ] - start;
	if ( size < 0 ) return nil;
	NSArray* spnts = [ points subarrayWithRange:NSMakeRange( start, size ) ];
	GifLine* line = [ [ GifLine alloc ] initWithData:spnts width:lineWidth red:r green:g blue:b ];
	[ line retain ];
	return line;
}

-(NSString*) description {
	int i;
	NSMutableString* str = [ NSMutableString stringWithFormat:@"W:%d, C:(%d,%d,%d), P:", lineWidth, r, g, b ];
	for ( i = 0; i < [ points count ]; i++ ) {
		[ str appendFormat:[ [ points objectAtIndex:i ] description ] ];
	}
	[ str retain ];
	return str;
}
@end